import x10.io.Console; 
import x10.util.Timer; 
import x10.io.File;

public class FileIO {
    static val THOUSAND = 1000;

    public static def main(argv:Array[String]{self.rank==1}) {

	var sum:Long;
	var start:Long;
	var end:Long;

	val bytes:Int;
	val filename:String;
	val trials:Int;

	if (argv.size != 3) {
	    Console.ERR.println("USAGE: FileIO <File Size (B)> <Path/To/File> <N trials>");
	    return;
	}

	bytes=Int.parseInt(argv(0));
	filename=argv(1);
	trials=Int.parseInt(argv(2));

	// first, measure write speed
	sum = 0;
	for (var t:Int = 0; t < trials; t++) {
	    start = Timer.milliTime();
	    val file  = new File(filename);
	    val stream  = file.openWrite();
	    for (var b:Int = 0; b < bytes; b++)
		stream.writeByte(0 as Byte);
	    stream.flush();
	    stream.close();
	    end = Timer.milliTime();
	    sum += (end-start);
	}

 	val avg=sum/trials; // time in ms
 	val rate=bytes/avg;
 	Console.OUT.println("Wrote to \"" + filename + "\" at " + rate + "B/ms (average of " + trials + " trials)");

	// then measure read speed
	sum = 0;
	for (var t:Int = 0; t < trials; t++) {
	    start = Timer.milliTime();
	    val file  = new File(filename);
	    val stream  = file.openRead();
	    for (var b:Int = 0; b < bytes; b++)
		stream.readByte();
	    stream.close();
	    end = Timer.milliTime();
	    sum += (end-start);
	}

 	val avg2=sum/trials; // time in ms
 	val rate2=bytes/avg2;
 	Console.OUT.println("Read from \"" + filename + "\" at " + rate2 + "B/ms (average of " + trials + " trials)");


   }

}