import x10.io.Console; 
import x10.util.Timer; 
import x10.util.Random;

public class Iteration {
    static val MAX_SIZE = 10000000;
    static val TRIALS = 10;

    public static def main(args:Array[String]) {
	Console.OUT.println("Iteration Timing Test (average of " + TRIALS + " trials, times in ms)");
	Console.OUT.println("Size\tInit.\tPoints\tIndices");

	var sum:Long;
	var start:Long;
	var end:Long;

	var initTime:Long;
	var pointTime:Long;
	var indexTime:Long;

	for(var size:Int = 1; size <= MAX_SIZE; size = size*10) {
	    sum = 0;
	    for (var t:Int = 0; t < TRIALS; t++) {
		start = Timer.milliTime();
		var arr1 : Array[Int](1) = new Array[Int](size, 0);  
		end = Timer.milliTime();
		sum += (end-start);
	    }
	    initTime = (sum/TRIALS);

	    sum = 0;
	    for (var t:Int = 0; t < TRIALS; t++) {
		start = Timer.milliTime();
		var arr2:Array[Int](1) = new Array[Int](size);
		for (i in arr2)
		    arr2(i) = 0;
		end = Timer.milliTime();
		sum += (end-start);
	    }
	    pointTime = (sum/TRIALS);

	    sum = 0;
	    for (var t:Int = 0; t < TRIALS; t++) {
		start = Timer.milliTime();
		var arr3 : Array[Int](1) = new Array[Int](size);
		for (var i:Int = 0; i < size; i++) 
		    arr3(i) = 0;
		end = Timer.milliTime();
		sum += (end-start);
	    }
	    indexTime = (sum/TRIALS);

	    Console.OUT.println(size + "\t" + initTime + "\t" + pointTime + "\t" + indexTime);
	}
    }
}


